var _editShapeId
var _editDivContent

document.onkeydown = function (event) {
    var e = event || window.event || arguments.callee.caller.arguments[0];
    //    if (e) {
    //        window.js2java.keyDownEvent(e.keyCode);
    //    }
    if (e && e.keyCode == 8) { //
        var node = document.getElementById('edit_content_text_node');
        if (node && node.childElementCount == 1) {
            var childNode = node.firstElementChild;
            if (childNode && (childNode.innerHTML == '<br>' || childNode.innerHTML == '&#65279;' || childNode.innerHTML == '')) {
                e.preventDefault(); //取消事件
                return;
            }
        }
    }
};

//document.onkeyup = function (event) {
//    var e = event || window.event || arguments.callee.caller.arguments[0];
//    if (e) { //
//        window.js2java.keyUpEvent(e.keyCode);
//    }
//}
//
//document.onkeypress = function (event) {
//    var e = event || window.event || arguments.callee.caller.arguments[0];
//    if (e) { //
//        window.js2java.keyPressEvent(e.keyCode);
//    }
//};

document.addEventListener("selectionchange", function (event) {
    _selectionChanged()
});

function _selectionChanged() {
	checkRangeChange()
    var selection = window.getSelection()
    if (!selection || selection.rangeCount == 0)
        return
    var rangeRect = selection.getRangeAt(0).getBoundingClientRect()
    var _left = rangeRect.left
    var _top = rangeRect.top
    if (_left == 0 && _top == 0) {
        if (!selection.focusNode)
            return
        var _focusNode = selection.focusNode
        if (!_focusNode.hasChildNodes() || _focusNode.childNodes.length != 1)
            return
        var _brNode = _focusNode.childNodes[0]
        if (_brNode.tagName != 'BR')
            return
        var _focusRect = _brNode.getBoundingClientRect()
        _left = _focusRect.left
        _top = _focusRect.top
    }
    var rootRect = document.getElementById('object1').getBoundingClientRect()
    window.js2java.rangeToScreen(_left - rootRect.left, _top - rootRect.top)
}

window.onload = function () {
    // document.getElementById('edit_text_root').addEventListener('mousedown', function test(event) {
    //     window.js2java.rangeToScreen(-1, -1);
    // })
    // document.getElementById('edit_text_root').addEventListener('mousemove', function test(event) {
    //     window.js2java.rangeToScreen(-1, -1);
    // })
    // document.getElementById('edit_text_root').addEventListener('mouseup', function test(event) {
    //     window.js2java.rangeToScreen(event.screenX, event.screenY);
    // })
    document.getElementById('edit_text_root').addEventListener('input', function test(event) {
        if (event.inputType == 'insertText')
            window.js2java.onTextChanged()
        else if (event.inputType == 'deleteContentBackward')
            _selectionChanged()
        window.js2java.inputText()
    })
}

function getTxt1CursorPosition() {
    var cursurPosition = -1;
    var range = window.getSelection().getRangeAt(0);
    cursurPosition = range.cursurPosition;
    return cursurPosition;
}

document.oninput = function (event) {
    var node = document.getElementById('edit_content_text_node');
    if (node && node.childElementCount == 1) {
        var childNode = node.firstElementChild;
        if (childNode && (childNode.innerHTML == '<br>' || childNode.innerHTML == '&#65279;' || childNode.innerHTML == '')) {
            childNode.innerHTML = "&#65279;";
        }
    }
    if (node) {
        var w = node.clientWidth || node.offsetWidth;
        var h = node.clientHeight || node.offsetHeight;
        window.js2java.obtainEditHeight(w, h);
    }
}

document.addEventListener("mousedown", function (event) {
    if (event && event.target) {
        var parent = document.getElementById('edit_text_node');
        if (parent) {
            if (parent == event.target || parent.contains(event.target))
                return;
        }
    }
    event.preventDefault();
})

document.addEventListener("scroll", function (event) {
    if (event && event.target) {
        var parent = document.getElementById('edit_text_root');
        if (parent.style.display != "none") {
            event.preventDefault();
        }
    }
})

// document.addEventListener('copy', function (event) {
//     event.preventDefault();
//     // document.getSelection();
//     // window.clipboardData.setData("Text", clipBoardContent);
//     document.execCommand('Copy');
// });


document.addEventListener('paste', function (event) {
    //var clipText = event.clipboardData.getData('Text');
    event.preventDefault();
    // var text = (event.originalEvent || event).clipboardData.getData('text/plain') || prompt('Paste something..');
    exchangeHtmlToPlain(event);
    // var pasteHtml = getPasteHtml(event, false, true);
    // document.execCommand('insertText', false, pasteHtml);
});

function inputText(text, selectAll) {
	var selection = window.getSelection()
	if (selection.rangeCount <= 0)
		return
	var range = selection.getRangeAt(0)
	if (selectAll)
		selectAllEditContent()
	document.execCommand('insertText', false, text)
}

function exchangeHtmlToPlain(e) {
    var clipboardData = e.clipboardData || e.originalEvent && e.originalEvent.clipboardData;
    var pasteText = void 0,
        pasteHtml = void 0;
    if (clipboardData == null) {
        pasteText = window.clipboardData && window.clipboardData.getData('text');
    } else {
        pasteText = clipboardData.getData('text/plain');
        pasteHtml = clipboardData.getData('text/html');
    }
    if (!pasteHtml && pasteText) {
        pasteHtml = replaceHtmlSymbol(pasteText);
    }
    if (!pasteHtml) {
        return;
    }
    window.js2java.insertText(pasteHtml);
}

function insertText(pasteHtml, isHtml) {
    if ('true' == isHtml)
        document.execCommand('insertHTML', false, pasteHtml);
    else
        document.execCommand('insertText', false, pasteHtml);
}

// //获取粘贴的html
// function getPasteHtml(e, filterStyle, ignoreImg) {
//     var clipboardData = e.clipboardData || e.originalEvent && e.originalEvent.clipboardData;
//     var pasteText = void 0,
//         pasteHtml = void 0;
//     if (clipboardData == null) {
//         pasteText = window.clipboardData && window.clipboardData.getData('text');
//     } else {
//         pasteText = clipboardData.getData('text/plain');
//         pasteHtml = clipboardData.getData('text/html');
//     }
//     if (!pasteHtml && pasteText) {
//         pasteHtml = replaceHtmlSymbol(pasteText);
//     }
//     if (!pasteHtml) {
//         return;
//     }

//     // 过滤word中状态过来的无用字符
//     var docSplitHtml = pasteHtml.split('</html>');
//     if (docSplitHtml.length === 2) {
//         pasteHtml = docSplitHtml[0];
//     }

//     // 过滤无用标签
//     pasteHtml = pasteHtml.replace(/<(meta|script|link).+?>/igm, '');
//     // 去掉注释
//     pasteHtml = pasteHtml.replace(/<!--.*?-->/mg, '');
//     // 过滤 data-xxx 属性
//     pasteHtml = pasteHtml.replace(/\s?data-.+?=('|").+?('|")/igm, '');

//     if (ignoreImg) {
//         // 忽略图片
//         pasteHtml = pasteHtml.replace(/<img.+?>/igm, '');
//     }

//     if (filterStyle) {
//         // 过滤样式
//         pasteHtml = pasteHtml.replace(/\s?(class|style)=('|").*?('|")/igm, '');
//     } else {
//         // 保留样式
//         pasteHtml = pasteHtml.replace(/\s?class=('|").*?('|")/igm, '');
//     }

//     return pasteHtml;
// }

// 替换 html 特殊字符
function replaceHtmlSymbol(html) {
    if (html == null) {
        return '';
    }
    return html.replace(/</gm, '&lt;').replace(/>/gm, '&gt;').replace(/"/gm, '&quot;').replace(/(\r\n|\r|\n)/g, '<br/>');
}

function revertFormat() {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    var node = document.getElementById('edit_text_node');
    if (!node)
        return;
    if (node.childElementCount > 0) {
        var tmpNode = document.createElement('div');
        tmpNode.appendChild(document.getElementById('edit_content_text_node').cloneNode(true));
        window.js2java.revertFormat(_editShapeId, tmpNode.innerHTML);
        tmpNode = null;
    } else
        window.js2java.revertFormat(_editShapeId, node.innerHTML);
}

function cancelBlur() {
    var focusNode = document.getElementById('Page-100');
    // if (focusNode) {
    //     focusNode.addEventListener('mousedown', function (event) {
    //         event.preventDefault();
    //     }, {
    //         passive: false
    //     });
    // }
}


// function cancelEvent(event) {
//     event.preventDefault();
// }


// function clearTimeInterval() {
//     window.clearInterval();
// }


function checkRangeChange() {
    var isBold = document.queryCommandValue('Bold');
    var isItalic = document.queryCommandValue('Italic');
    var isUnderline = document.queryCommandValue('Underline');
    var isStrikeThrough = document.queryCommandValue('StrikeThrough');
    var mForeColor = document.queryCommandValue('ForeColor');
    var mBackColor = document.queryCommandValue('BackColor');
    window.js2java.changeFormatBtmStates(_editShapeId, isBold, isItalic, isUnderline, isStrikeThrough, mForeColor, mBackColor);
}

function canRangeOpe() {
    var selection = window.getSelection();
    return (!selection || selection.rangeCount == 0);
}

function clearFormatText() {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    var node = document.getElementById('edit_text_node');
    if (!node)
        return;
    selection.selectAllChildren(node);
    document.execCommand('RemoveFormat');
    selection.collapseToEnd();
}

function boldText() {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    document.execCommand('Bold');
}

// function boldText2() {
//     var selection = window.getSelection();
//     if (!selection || selection.rangeCount == 0)
//         return;
//     var range = selection.focusOffset;
//     var node = document.getElementById('edit_text_node');
//     if (!node)
//         return;
//     selection.selectAllChildren(node);
//     document.execCommand('Bold');
//     selection.collapseToEnd();
//     selection.setPosition(range);
// }

function italicText() {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    document.execCommand('Italic');
}

function underlineText() {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    document.execCommand('Underline');
}

function strikeThroughText() {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    document.execCommand('StrikeThrough');
}

function foreColorText(color) {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    document.execCommand('ForeColor', false, color);
}


function bgColorText(color) {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    if (selection.anchorOffset == selection.focusOffset) {
        var contentNode = document.getElementById('edit_content_text_node');
        if (contentNode && contentNode.childElementCount == 1) {
            var childNode = contentNode.firstElementChild;
            if (childNode && (childNode.innerHTML == '<br>' || childNode.innerHTML == '&#65279;' || childNode.innerHTML == '')) {
                var range = selection.getRangeAt(0);
                childNode.setAttribute("style", "background-color: " + color);
                range.selectNodeContents(childNode)
                childNode.focus();
                selection.collapseToEnd();
                document.execCommand('BackColor', false, color);
                if ('rgba(0,0,0,0.0)' == color)
                    document.execCommand("insertHTML", null, '&#65279;');
                return;
            }
        }

        var range = selection.getRangeAt(0);
        var node = document.createElement('span');
        node.innerHTML = '&#65279;';
        node.setAttribute("style", "background-color: " + color);
        range.insertNode(node);
        range.selectNodeContents(node)
        node.focus()
        selection.collapseToEnd();
        document.execCommand('BackColor', false, color);
        if ('rgba(0,0,0,0.0)' == color)
            document.execCommand("insertHTML", null, '&#65279;');
    } else
        document.execCommand('BackColor', false, color);
}

//JustifyCenter JustifyLeft JustifyRight
function alignText(mAlign) {
    var selection = window.getSelection();
    if (!selection || selection.rangeCount == 0)
        return;
    document.execCommand(mAlign);
}

function focusEditNode(selectAll) {
    var node = document.getElementById('edit_text_node');
    if (!node)
        return;
    var mChild = findLastChild(node);
    if (mChild) {
        var selection = window.getSelection();
        selection.selectAllChildren(mChild);
        mChild.focus();
        if ('false' == selectAll)
            selection.collapseToEnd();
    }
}

function selectAllEditContent() {
	var selection = window.getSelection()
	if (selection.rangeCount <= 0)
        return
	var range = selection.getRangeAt(0)
	var container = range.endContainer
	range.selectNodeContents(container)
}

function findLastChild(parentNode) {
    var mChild = parentNode.lastChild;
    if (mChild && mChild.nodeName != '#text') {
        var mc = findLastChild(mChild);
        return mc;
    }
    return parentNode;
}

function saveEditText() {
    //var selection = window.getSelection();
    var selection = window.getSelection();
    selection.removeAllRanges();
    var node = document.getElementById('edit_text_node');
    if (node) {
        if (node.childElementCount > 1) {
            var tmpNode = document.createElement('div');
            tmpNode.appendChild(document.getElementById('edit_content_text_node').cloneNode(true));
            window.js2java.saveEditText(tmpNode.innerHTML, _editShapeId, _editDivContent);
            tmpNode = null;
            _editShapeId = 0
            _editDivContent = ''
        } else {
            window.js2java.saveEditText(node.innerHTML, _editShapeId, _editDivContent)
            _editShapeId = 0
            _editDivContent = ''
        }
    }
}

function changeEdit() {
    //var selection = window.getSelection(); //创建range
    var node = document.getElementById('edit_text_node');
    if (node) {
        if (node.childElementCount > 0) {
            var tmpNode = document.createElement('div');
            tmpNode.appendChild(document.getElementById('edit_content_text_node').cloneNode(true));
            window.js2java.changeAnotherEdit(tmpNode.innerHTML, _editShapeId, _editDivContent);
            tmpNode = null;
        } else
            window.js2java.changeAnotherEdit(node.innerHTML, _editShapeId, _editDivContent);
    }
}

function animateTo(m_id, m_attr) {
    var node = Snap("#" + m_id);
    if (!node)
        return;
    node.animate(JSON.parse(m_attr), 300);
}

function updateInnerHtml(parentId, elementId, tag, attr, mInnerHtml) {
    var SVG_NS = "http://www.w3.org/2000/svg";
    //var XLINK_NS = "http://www.w3.org/1999/xlink";
    var child = document.createElementNS(SVG_NS, tag);
    var obj = JSON.parse(attr);
    //console.log('start-------------');
    for (var key in obj) {
        //console.log(key+' '+obj[key]);
        switch (key) {
            case 'xlink:href':
                child.setAttributeNS("http://www.w3.org/2000/svg", "xlink:href", obj[key]);
                break;
            default:
                child.setAttribute(key, obj[key]);
                break;
        }
    }
    var pn = document.getElementById(parentId);
    var node = document.getElementById(elementId);
    if (!pn)
        return 'fail';
    child.innerHTML = mInnerHtml;
    if (!node) {
        pn.appendChild(child);
    } else {
        pn.removeChild(node);
        pn.appendChild(child);
        //pn.replaceChild(child,node);
    }
    return 'success';
}

function updatePageInnerHtml(parentId, elementId, tag, attr, mInnerHtml) {
    var SVG_NS = "http://www.w3.org/2000/svg";
    var pn = document.getElementById(parentId);
    if (!pn)
        return 'fail';
    var child;
    if ("" != attr) {
        child = document.createElementNS(SVG_NS, tag);
        if (!child) {
            pn.appendChild(child);
        }
        var obj = JSON.parse(attr);
        for (var key in obj) {
            switch (key) {
                case 'xlink:href':
                    child.setAttributeNS("http://www.w3.org/2000/svg", "xlink:href", obj[key]);
                    break;
                default:
                    child.setAttribute(key, obj[key]);
                    break;
            }
        }
    } else {
        child = document.getElementById(elementId);
    }
    child.innerHTML = mInnerHtml;
    return 'success';
}

function updateEditInnerHtml(mInnerHtml, attr, selectAll, editShapeId, editDivContent) {
    var editNode = document.getElementById('edit_text_root');
    if (!editNode)
        return 'fail';
    _editShapeId = editShapeId
    _editDivContent = editDivContent
    editNode.setAttribute("display", "block");

    var obj = JSON.parse(attr);
    for (var key in obj) {
        switch (key) {
            case 'xlink:href':
                editNode.setAttributeNS("http://www.w3.org/2000/svg", "xlink:href", obj[key]);
                break;
            default:
                editNode.setAttribute(key, obj[key]);
                break;
        }
    }
    editNode.innerHTML = mInnerHtml;
    var pageNode = Snap("#Page-100");
    var eNode = Snap("#edit_text_root");
    if (pageNode && eNode) {
        eNode.after(pageNode);
    }
    focusEditNode(selectAll);

    var textNode = document.getElementById('edit_text_node');
    var w = textNode.clientWidth || textNode.offsetWidth;
    var h = textNode.clientHeight || textNode.offsetHeight;
    window.js2java.obtainEditHeight(w, h);
    return 'success';
}

function afterNode(afterId, beforeId) {
    var node1 = document.getElementById(afterId);
    if (node1) {
        var parent = node1.parentElement;
        if (parent) {
            parent.removeChild(node1);
            parent.appendChild(node1);
        }
    }
}

function removeNode(parentId, elementId) {
    var pn = document.getElementById(parentId);
    var node = document.getElementById(elementId);
    if (!pn || !node) {
        return;
    }
    pn.removeChild(node);
}

function clearInnerHtml(elementId, mInnerHtml) {
    var node = document.getElementById(elementId);
    if (node)
        node.innerHTML = mInnerHtml;
}

function updateEditAttr(parent_id, el_name, m_id, m_attr, txt) {
    var m_ele = Snap("#" + m_id);
    if (m_ele) {
        m_ele.attr(JSON.parse(m_attr));
        if (el_name == 'span') {
            var node = document.getElementById(m_id);
            if (node)
                node.innerHTML = txt;
        }
    } else {
        var SVG_NS = "http://www.w3.org/2000/svg";
        var XLINK_NS = "http://www.w3.org/1999/xlink";
        var child;
        if (el_name == 'div') {
            child = document.createElement(el_name);
            child.setAttribute("xmlns", "http://www.w3.org/1999/xhtml");
        } else
            child = document.createElementNS(SVG_NS, el_name);
        if (!child) {
            return 'error';
        }
        child.setAttribute("id", m_id);
        var obj = JSON.parse(m_attr);
        for (var key in obj) {
            switch (key) {
                case 'xlink:href':
                    child.setAttributeNS(XLINK_NS, "xlink:href", obj[key]);
                    break;
                default:
                    child.setAttribute(key, obj[key]);
                    break;
            }
        }
        if (el_name == 'span') {
            child.innerHTML = txt;
        }
        var parentNode = document.getElementById(parent_id);
        if (parentNode) {
            parentNode.appendChild(child);
        }
    }
    return 'success';
}

function updateAttr(parent_id, el_name, m_id, m_attr, txt) {
    var m_ele = Snap("#" + m_id);
    if (m_ele) {
        m_ele.attr(JSON.parse(m_attr));
        if (el_name == 'tspan') {
            var node = document.getElementById(m_id);
            if (node)
                node.innerHTML = txt;
        }
    } else {
        var node = createNode(parent_id, el_name, m_attr);
        if (el_name == 'tspan' && node)
            node.innerHTML = txt;
    }

    return 'success';
}

function deleteNode(m_id) {
    //    console.log(m_id);
    var m_ele = Snap("#" + m_id);
    if (m_ele) {
        m_ele.remove();
    }
    return 'success';
}

function showNode(m_id) {
    var m_ele = Snap("#" + m_id);
    if (m_ele) {
        m_ele.attr({
            display: "inline-block"
        });
    }
    return 'success';
}

function hideNode(m_id) {
    var m_ele = Snap("#" + m_id);
    if (m_ele) {
        m_ele.attr({
            display: "none"
        });
    }
    return 'success';
}

function hideTextBackground(nodeId) {
	var element = document.getElementById(nodeId)
	if (!element || element.childElementCount <= 0)
		return;
	for (var i = 0; i < element.children.length; i++) {
		if (element.children[i].tagName == 'rect') {
			element.children[i].setAttribute('display', 'none');
		}
	}
}

function createNode(parentId, tag, attr) {
    var SVG_NS = "http://www.w3.org/2000/svg";
    var XLINK_NS = "http://www.w3.org/1999/xlink";
    var node = document.getElementById(parentId);
    if (!node)
        return;
    var child;
    if (tag == 'div')
        child = document.createElement(tag);
    else
        child = document.createElementNS(SVG_NS, tag);
    var obj = JSON.parse(attr);
    for (var key in obj) {
        switch (key) {
            case 'xlink:href':
                child.setAttributeNS(XLINK_NS, "xlink:href", obj[key]);
                break;
            default:
                child.setAttribute(key, obj[key]);
                break;
        }
    }
    node.appendChild(child);
    return child;
}

function resetNodeAttr(elementId, attr) {
    var node = document.getElementById(elementId);
    if (!node)
        return;
    var obj = JSON.parse(attr);
    for (var key in obj) {
        if (obj[key] == 'undefined')
            node.removeAttribute(key);
        else
            node.setAttribute(key, obj[key]);
    }
}

function removeNodeAttr(elementId, attr) {
    var node = document.getElementById(elementId);
    if (!node)
        return;
    var obj = JSON.parse(attr);
    for (var key in obj) {
        node.removeAttribute(key);
        return;
    }
}

//function filterHtml(str, callback) {
//    var s = '';
//    var imgWidth = 200;
//    var d = str.replace(/(&nbsp;)/ig, ''); //先过滤空格
//    var sd = d.replace(/<br([^<>]+|\s?)>/ig, '||||'); //替换br标签
//    var div = document.createElement('div');
//    div.id = 'cache_Id';
//    div.style.display = 'none';
//    div.innerHTML = sd;
//    document.body.appendChild(div);
//    var dssD = document.getElementById('cache_Id');
//    var text = dssD.innerText; //过滤html标签
//    text = text.replace(/\|\|\|\|/g, '<br>'); //还原br
//    var imagesCount = 0;
//    try {
//        var temp = '';
//        var img = dssD.getElementsByTagName('img');
//        if (img.length > 0) {
//            for (var i = 0; i < img.length; i++) {
//                var imgObj = new Image();
//                imgObj.onload = function () {
//                    imagesCount++;
//                    var w = this.width;
//                    var h = this.height;
//                    if (w > imgWidth) {
//                        temp += '<img src="' + this.src + '" width="' + imgWidth + '" /><br>';
//                    } else {
//                        temp += '<img src="' + this.src + '" width="' + w + '" /><br>';
//                    }
//                    if (imagesCount == img.length) {
//                        text += temp;
//                        s = text;
//                        var n = document.getElementById('cache_Id');
//                        if (n && n.parentNode && n.tagName != 'BODY') {
//                            n.parentNode.removeChild(n);
//                        }
//                        if (callback) {
//                            callback(s);
//                        }
//                    }
//                }
//                imgObj.onerror = onabort = function () {
//                    console.log(imagesCount);
//                    imagesCount++;
//                    if (imagesCount == img.length) {
//                        s = text;
//                        var n = document.getElementById('cache_Id');
//                        if (n && n.parentNode && n.tagName != 'BODY') {
//                            n.parentNode.removeChild(n);
//                        }
//                        if (callback) {
//                            callback(s);
//                        }
//                    }
//                }
//                imgObj.src = img[i].src;
//            }
//        } else {
//            s = text;
//            var n = document.getElementById('cache_Id');
//            if (n && n.parentNode && n.tagName != 'BODY') {
//                n.parentNode.removeChild(n);
//            }
//            if (callback) {
//                callback(s);
//            }
//        }
//    } catch (e) {
//        console.log(e);
//    }
//}

function getSelectionCoords(win) {
    win = win || window;
    var doc = win.document;
    var sel = doc.selection,
        range, rects, rect;
    var x = 0,
        y = 0;
    if (sel) {
        if (sel.type != "Control") {
            range = sel.createRange();
            range.collapse(true);
            x = range.boundingLeft;
            y = range.boundingTop;
        }
    } else if (win.getSelection) {
        sel = win.getSelection();
        if (sel.rangeCount) {
            range = sel.getRangeAt(0).cloneRange();
            if (range.getClientRects) {
                range.collapse(true);
                rects = range.getClientRects();
                if (rects.length > 0) {
                    rect = rects[0];
                }
                // 光标在行首时，rect为undefined
                if (rect) {
                    x = rect.left;
                    y = rect.top;
                }
            }

            // Fall back to inserting a temporary element
            if ((x == 0 && y == 0) || rect === undefined) {
                var span = doc.createElement("span");
                if (span.getClientRects) {
                    // Ensure span has dimensions and position by
                    // adding a zero-width space character
                    span.appendChild(doc.createTextNode("\u200b"));
                    range.insertNode(span);
                    rect = span.getClientRects()[0];
                    x = rect.left;
                    y = rect.top;
                    var spanParent = span.parentNode;
                    spanParent.removeChild(span);
                    // Glue any broken text nodes back together
                    spanParent.normalize();
                }
            }
        }
    }

    return {
        x: x,
        y: y
    };

}

function exchangeSelectionColor(color) {
    document.body.style.setProperty('--selcolor', color);
}